#include "desk.h"

/*	ROUTINES DE GESTION D'EVENEMENTS	*/

/* dtermine  quel objet obp et  quelle case cp appartient le point (x,y) de l'cran
	retourne aussi (dxp,dyp) coordonnes de (x,y) dans la case cp	*/
void objetvise(obp,cp,dxp,dyp,x,y)
	objet	*obp;
	cas	*cp;
	int	*dxp,*dyp,x,y;
	{
		objet	ob;
		cas	c;
		int	dx,dy;

	asm	{
		MOVEM.L	D0-D3/A0-A4,-(SP)
		MOVE.L	sys,A3
		MOVE.L	#NULL,ob
		MOVE.L	#NULL,c
		MOVE.L	DEBPILE(A3),A2
		MOVE.W	NBOP(A3),D2
		BEQ	@FIN
		BTST	#4,STATE+1(A3)
		BEQ	@4
		MOVEQ	#1,D2
		MOVE.L	A2,D0
		CMP.L	OBMOUSE(A3),D0
		BNE	@4
		MOVEQ	#2,D2
		BRA	@4
	@0	MOVE.L	A2,A1
		MOVE.L	NEXTP(A2),A2
		CMP.L	OBMOUSE(A3),A1
		BEQ	@4
		MOVE.W	x,D0
		MOVE.W	y,D1
		MOVE.L	A1,A4
		BRA	@7
	@6	MOVE.L	PERE(A4),A4
		MOVE.L	A4,A0
		ADD.L	OFMAIN(A4),A0
		SUB.W	XOE(A0),D0
		SUB.W	YOE(A0),D1
	@7	TST.L	PERE(A4)
		BNE	@6
		MOVE.L	OFMAIN(A1),A0
		ADD.L	A1,A0
		SUB.W	XOE(A0),D0
		BMI	@4
		CMP.W	LARGO(A0),D0
		BHI	@4
		SUB.W	YOE(A0),D1
		BMI	@4
		CMP.W	HAUTO(A0),D1
		BLS	@5
	@4	MOVE.L	A2,D0
		BEQ	@FIN
		DBRA	D2,@0
		BRA	@FIN
	
	@5	MOVE.L	A1,ob
		MOVE.L	OFEVEN(A1),A0
		ADD.L	A1,A0
		MOVE.W	NCASE(A0),D2
		LEA.L	TBCASE(A0),A0
		BRA	@3
	@1	CMP.W	XCMN(A0),D0
		BLT	@2
		CMP.W	XCMX(A0),D0
		BGT	@2
		CMP.W	YCMN(A0),D1
		BLT	@2
		CMP.W	YCMX(A0),D1
		BGT	@2
		MOVE.L	A0,c
		MOVE.W	D0,D3
		SUB.W	XCMN(A0),D3
		MOVE.W	D3,dx
		MOVE.W	D1,D3
		SUB.W	YCMN(A0),D3
		MOVE.W	D3,dy
	@2	MOVE.W	SIZEC(A0),D3
		EXT.L	D3
		ADD.L	D3,A0
	@3	DBRA	D2,@1
	@FIN	MOVEM.L	(SP)+,D0-D3/A0-A4
		}
	*obp=ob; *cp=c; *dxp=dx; *dyp=dy;
	sys->flzone=0;
	}

/* dplace la souris sur sa nouvelle position
	(tient compte du changement ventuel d'objet souris)	*/
void depmouse()
	{
		struct Fen	f;
		objet	obm=sys->obmouse,b=sys->obml;
		mainp	a=calcmainp(obm);

	clearfenclc(&f);
	if (b!=NULL) ajobjclc(b,&f);
	a->xoe=sys->xml-a->deltax;
	a->yoe=sys->yml-a->deltay;
	ajobjclc(obm,&f);
	sys->obml=obm;
	affenclc(&f);
	}

/* rend actif le curseur du work(ob,n)
	(et donc dsactive l'ancien curseur)	*/
void chgcurseur(ob,n)
	objet	ob;
	int	n;
	{
		work w=calcwork(ob);
	
	if ((ob!=sys->obcsr)||(ob->workcurs!=n))
		{
		effcurseur();
		ob->workcurs=n;
		sys->obcsr=ob;
		(sys->tbcomm)[10]=ob->proc;
		(sys->pid)[ob->proc]->tbcomm[10]=ob->sproc;
		}
	}

/* gre le clignotement du curseur	*/
void cligno()
	{
		objet	 ob=sys->obcsr;
		int 	 n;
		unsigned int k=clock()-sys->comptc;

	if	((ob!=NULL)
		&&(calcworkn(ob,(n=ob->workcurs))->inv&8)
		&&(k>sys->duree))
			{
			afcurs(ob,n);
			sys->comptc=clock();
			afworkmodif(ob);
			}
	}

/* fait passer l'objet ob (et tous ses fils) au premier plan du bureau
	(en conservant l'ordre de la 'famille')	*/
void devant(ob)
	objet	ob;
	{
		int	i;
		objet	p,q,fp=NULL,fq=NULL,r,s;
	
	r=sys->debpile;
	while(r)	{	/* calcule la liste p des objets apparents  ob
				et la liste q des autres	*/
		s=r;
		while((s)&&(s!=ob)) s=s->pere;
		if (s)	{
			if (fp)	{
				r->prevp=p;
				p->nextp=r;
				p=r;
				}
				else
				fp=p=r;
			}
			else
			{
			if (fq)	{
				r->prevp=q;
				q->nextp=r;
				q=r;
				}
				else
				fq=q=r;
			}
		r=r->nextp;
		}	
			/* fusionne les deux listes : p devant, q derrire */
	if (fp)	{
		sys->debpile=fp;
		fp->prevp=NULL;
		p->nextp=fq;
		if (fq)	{
			fq->prevp=p;
			q->nextp=NULL;
			}
		}
		else
		{
		sys->debpile=fq;
		if (fq)	{
			fq->prevp=NULL;
			q->nextp=NULL;
			}
		}
	}
	
/* fait passer l'objet ob (et tous ses fils)  l'arrire-plan du bureau
	(en conservant l'ordre de la 'famille')	*/
void derriere(ob)
	objet	ob;
	{
		int	i;
		objet	p,q,fp=NULL,fq=NULL,r,s;
	
	r=sys->debpile;
	while(r)	{	/* calcule la liste p des objets apparents  ob
				et la liste q des autres	*/
		s=r;
		while((s)&&(s!=ob)) s=s->pere;
		if (s)	{
			if (fp)	{
				r->prevp=p;
				p->nextp=r;
				p=r;
				}
				else
				fp=p=r;
			}
			else
			{
			if (fq)	{
				r->prevp=q;
				q->nextp=r;
				q=r;
				}
				else
				fq=q=r;
			}
		r=r->nextp;
		}	
			/* fusionne les deux listes : q devant, p derrire */
	if (fq)	{
		sys->debpile=fq;
		fq->prevp=NULL;
		q->nextp=fp;
		if (fp)	{
			fp->prevp=q;
			p->nextp=NULL;
			}
		}
		else
		{
		sys->debpile=fp;
		if (fp)	{
			fp->prevp=NULL;
			p->nextp=NULL;
			}
		}
	}

/* Gestionnaire d'vnements */
void TstEvent()
{
	Point	m;
	objet	objv;
	cas	casv;
	int	b,dx,dy,t;
	int	np;
	int	nsp,k;

np=process; nsp=sprocess;
process=sys->psys; sprocess=sys->spsys;

GetMouse(&m);
b=Button()&1;
			/* PARTIE 'CHANGEMENT DE ZONE' */
if ((sys->flzone)||(m.h!=sys->xml)||(m.v!=sys->yml)||(b!=sys->btl))
	{
	objetvise(&objv,&casv,&dx,&dy,sys->xml=m.h,sys->yml=m.v);
			
			/* SORTIE DE ZONE */
	if (casv!=sys->casv)
		{
		SendQuit(sys->objv,sys->casv,Defaut);
		(sys->tbcomm)[7]=Nid;
		   /* GESTION DES CASES SPECIALES (INVERSEES LORSQU'ON CLIQUE DESSUS)*/
		if ((sys->typlc&1)&&(sys->casv==sys->calc))
			{
			notcase(sys->oblc,sys->calc);
			afworkmodif(sys->oblc);
			}
			
			/* ENTREE DE ZONE */
		sys->objv=objv; sys->casv=casv;
		if ((sys->state&1)&&(casv))
			{
			SendEnter(objv,casv,k=casv->zone);
			if (present(k))
				{
				(sys->tbcomm)[7]=(sys->sid)[k]->pere;
				(sys->pid)[(sys->tbcomm)[7]]->tbcomm[7]=k;
				}
			}
		   /* GESTION DES CASES SPECIALES (INVERSEES LORSQU'ON CLIQUE DESSUS)*/
		if ((sys->typlc&1)&&(casv==sys->calc))
			{
			notcase(objv,casv);
			afworkmodif(objv);
			}
		}

		/* ENVOIE COMM DE DEPLACEMENT DE LA SOURIS */
	SendMove(sys->xml,sys->yml,Defaut);
	
		/* GESTION DU BOUTON DE LA SOURIS */
	if (b!=sys->btl)
		{
			/* PARTIE 'CLICK' */
		if ((sys->state&2)&&(b==1))
			{
			sys->btl=1;
			sys->typlc=0;

				/* GESTION N-CLICK */
			if (sys->clknid!=Nid)
			  {
			  sys->clkn++;
			  if (sys->clkn>1)
			  	SendClickn(sys->oblc,sys->calc,sys->clkn,sys->clknid);
			  }
			  else sys->clkn=1;
			sys->clkc=clock();
			
				/* CLICK SUR LE FOND DU BUREAU */
			if ((objv==NULL)&&((sys->state&16)==0))
				{
				SendClick(objv,casv,dx,dy,Defaut);
				if (sys->clknid==Nid) sys->clknid=Defaut;
				sys->oblc=NULL; sys->calc=NULL;
				if(((sys->tbcomm)[9]=(sys->tbcomm)[8])!=Nid)
				 (sys->pid)[(sys->tbcomm)[8]]->tbcomm[9]
				 	=(sys->pid)[(sys->tbcomm)[8]]->tbcomm[8];
				}
			else
			  {
			  	/* CLICK NORMAL SUR UNE CASE D'UN OBJET */
			  if (casv)	{
				SendClick(objv,casv,dx,dy,k=casv->clk);
				if (sys->clknid==Nid) sys->clknid=k;
				if (present(k))
					{
					(sys->tbcomm)[9]=(sys->sid)[k]->pere;
					(sys->pid)[(sys->tbcomm)[9]]->tbcomm[9]=k;
					}
				sys->oblc=objv;
				sys->calc=casv;
				t=sys->typlc=casv->typc;
				
		/* GESTION DES CASES SPECIALES (INVERSEES LORSQU'ON CLIQUE DESSUS)*/
				if (t&1)	{
					notcase(objv,casv);
					afworkmodif(objv);
					}
		/* GESTION DES CASES SPECIALES (DEPLACEMENT DE L'OBJET
					 LORSQU'ON CLIQUE DESSUS)*/
				if (t&2)	{
					mainp p=calcmainp(objv);
					sys->obms=sys->obmouse;
					depile(sys->obms);
					sys->obmouse=sys->objv;
					p->deltax=sys->xml-p->xoe;
					p->deltay=sys->yml-p->yoe;
					if (t&4)
						derriere(objv);
						else
						devant(objv);
					sys->state&=0xfff8;
					}
				}
			  }
			}
				/* PARTIE 'FIN DE CLICK' */
		if (b==0)	{
			sys->btl=0;
			t=sys->typlc;
			if (((t&1)==0)||(casv==sys->calc))
				SendClickE(objv,casv,dx,dy,Defaut);
			(sys->tbcomm)[9]=Nid;

		/* GESTION DES CASES SPECIALES (INVERSEES LORSQU'ON CLIQUE DESSUS)*/
			if ((t&1)&&(sys->calc==casv))
					{
					notcase(objv,casv);
					afworkmodif(objv);
					}

		/* GESTION DES CASES SPECIALES (DEPLACEMENT DE L'OBJET
					 LORSQU'ON CLIQUE DESSUS)*/
			if (t&2)	{
				mainp p=calcmainp(sys->obms);
				p->xoe=sys->xml-p->deltax;
				p->yoe=sys->yml-p->deltay;
				sys->obmouse=sys->obms;
				empile(sys->obms,0);
				sys->state|=0x000f;
				}
			sys->typlc=0;
			}
		}

			/* DEPLACEMENT DE LA SOURIS */
	if (sys->state&8) depmouse();
	}

			/* GESTION N-CLICK */
if (clock()-sys->clkc >sys->clktime) sys->clknid=Nid;

			/* PARTIE 'CLAVIER' */
if (sys->state&4)
	{
	int c=inkey()&255;
	if (c) SendChar(c,Defaut);
	}
			/* CLIGNOTEMENT CURSEUR */
cligno();

			/* ROUTINE EVENTUELLE DE L'UTILISATEUR */
if (sys->always) (*sys->always)();

process=np; sprocess=nsp;
}

/* initialisation du systme	*/
void *inisys()
{
	mainp a;

	asm
		{
		LEA.L	@SYS0,A0
		MOVE.L	A0,sys
		LEA.L	@FONTESYS,A1
		MOVE.L	A1,FONTESYS(A0)
		LEA.L	@FONDSTD,A1
		MOVE.L	A1,MASKF(A0)
		BRA	@FIN
		
		DC.W	0,0,0
		DC.W	0,0,0,0,0,0,0
	@SYS0	DC.L	-20
		DC.L	0,0,0,0,0,0,0,0
		DC.L	0,0,0,0,0,0,0,0
		DC.L	0,0,0,0,0,0,0,0
		DC.L	0,0,0,0,0,0,0,0
		DC.L	0,0,0,0,0,0,0,0
		DC.L	0,0,0,0,0,0,0,0
		DC.L	0,0,0,0,0,0,0,0
	
	@FONDSTD	DC.L	0X5555AAAA,0X5555AAAA,0X5555AAAA,0X5555AAAA
		DC.L	0X5555AAAA,0X5555AAAA,0X5555AAAA,0X5555AAAA
		
		DC.W	0X8181,0X4182,0X2184,0X11C8,0X08E0,0X0470,0X0238,0XF19F
		DC.W	0XF98F,0X1C40,0X0E20,0X0710,0X1388,0X2184,0X4182,0X8181
		
	@FONTESYS		/* fonte standard  8 points x 8 points */
		dc.w	8,8,0xff
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dc.l	0,0,0x18181818,0x18001800,0x66666600,0,0x6cfe6c,0x6cfe6c00
		dc.l	0x183e5838,0x1c1a7c18,0x66660c18,0x30666600,0x70d836cc,0xcccc7600,0x18181800,0
		dc.l	0x1c303030,0x30301c00,0x380c0c0c,0x0c0c3800,0xd638,0xee38d600,0x1818,0x7e181800
		dc.l	0,0x18183000,0,0x7e000000,0,0x181800,0x06060c18,0x30606000
		dc.l	0x3c666e7e,0x76663c00,0x18781818,0x18187e00,0x3c66060c,0x30607e00,0x3c66061c,0x06663c00
		dc.l	0x1c3c6ccc,0xfe0c1e00,0x7e60607c,0x06067c00,0x3c60607c,0x66663c00,0x7e060c18,0x18181800
		dc.l	0x3c66663c,0x66663c00,0x3c66663e,0x06063c00
		dc.l	0x1818,0x181800,0x1800,0x18183000,0x61860,0x60180600,0x7e,0x7e0000
		dc.l	0x601806,0x6186000,0x3c66060c,0x18001800,0x7cc6c676,0xd6d67800
		dc.l	0x3c66667e,0x66666600,0x7c66667c,0x66667c00,0x3c666060,0x60663c00,0x78666666,0x66667800
		dc.l	0x7e606078,0x60607e00,0x7e606078,0x60606000,0x3c66606e,0x66663c00,0x6666667e,0x66666600
		dc.l	0x7e181818,0x18187e00,0x1e060606,0x06663c00,0x66666c70,0x6c666600,0x60606060,0x60607e00
		dc.l	0x42667e7e,0x66666600,0x6676767e,0x6e6e6600,0x3c666666,0x66663c00,0x7c66667c,0x60606000
		dc.l	0x3c666666,0x766e3e00,0x7c66667c,0x6c666600,0x3c66603c,0x06663c00,0x7e181818,0x18181800
		dc.l	0x66666666,0x66663c00,0x66666666,0x663c1800,0x66666666,0x7e664200,0x66663c18,0x3c666600
		dc.l	0x6666663c,0x18181800,0x7e060c18,0x30607e00
		dc.l	0x7e606060,0x60607e00,0x60603018,0x0c060600,0x7e060606,0x06067e00,0x183c6666,0,0,0x7e00,0xff,0
		dc.l	0x3e66,0x66663e00,0xe0607c66,0x6666fc00,0x3e60,0x60603e00,0x0e063e66,0x66663e00
		dc.l	0x3c66,0x7e603c00,0x3c6660f8,0x6060f000,0x3e66,0x663e067c,0xe0607c66,0x6666e600
		dc.l	0x18007818,0x18187e00,0x0c003c0c,0x0c0c1830,0xe0606c78,0x786ce600,0x78181818,0x18187e00,0xecd6,0xd6d6d600
		dc.l	0xfc66,0x6666e600,0x3c66,0x66663c00,0xfc66,0x667c60f0,0x3e66,0x663e060e
		dc.l	0xfc66,0x6060f000,0x3c60,0x3c063c00,0x307e30,0x30301c00,0xe666,0x66663e00,0x6666,0x663c1800
		dc.l	0x6666,0x667e6600,0x6666,0x18666600,0xe666,0x663e067c,0x7e0c,0x18307e00
		dc.l	0x06181870,0x18180600,0x18181818,0x18181818,0x6018180e,0x18186000,0xff000000,0,-1,-1
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		
	@FIN
		}
	sys->nbop=0;
	sys->debpile=NULL;
	sys->adbufwnd=(long) malloc(32000);
	a=(mainp) ((long) sys + sys->ofmains);
	a->typo=0;
	a->adbo=adec;
	a->largoo= voffs;
	a->largo=nbcl-1;
	a->hauto=nbln-1;
	sys->xml=sys->yml=sys->btl=0;
	sys->obml=NULL; sys->obmouse=NULL;
	sys->obcsr=NULL; sys->objv=NULL; sys->casv=NULL;
	sys->duree=35; sys->comptc=0;
	sys->state=0x000f;
	sys->always=NULL;
	sys->typlc=0;
	sys->listob=NULL;
	sys->clknid=Nid;
	sys->clkn=0;
	sys->clktime=60;
	sys->adec=adec;
	sys->voffs=voffs;
	sys->nbcl=nbcl;
	sys->nbln=nbln;
	inifn();
	Iniprocess();
	IniComm();
	return Inimem();
	}

/* dsinstallation du systme	*/
void endsys()
	{
	free((void*) sys->adbufwnd);
	free((void*) sys->bcomm);
	free((void*) (sys->pid));
	free(sys->first->end);
	}


/* scheduler : last est le dernier pointeur de pile systme (sp) 
	retourne le nouveau sp		*/
long scheduler(last)
	long	last;
	{
		sproc	q;
		proc	p;
		int	nq;
		int	np=Nid;
		int	i,j,f,g,c;
	
	if (present(sprocess)) (sys->sid)[sprocess]->spp=last;		/*stocke le dernier sp */
	if (present(process)) np=(sys->pid)[process]->next;
	i=-1;
	c=clock();
	if (sys->state>=0)		/* sortie du systme ? */
	  do			/* - non */
	  {
	  f=i;
	  while(np!=Nid)	/* boucle sur les processus */
		{
		p=(sys->pid)[np];
		if (p->fl==2)  /* gestion des minuteries pour les processus en attente */
			{
			nq=p->spro;
			while(nq!=Nid)
				{
				q=(sys->sid)[nq];			
				if ((q->flclock)&&(q->clockn-c<=0))
					{
					SendClock(c,nq);
					if (q->flclock>0)
						q->clockn+=q->flclock;
						else q->flclock=0;	
					}
				nq=q->next;
				}
			}
		if (p->fl==1)
			{
			f+=2;
			sys->calcu+=p->pr;
			p->kprio+=p->pr;
			if (p->kprio>=sys->total)	/* processus choisi proportionnellement*/
				{	/*  sa priorit */
				p->kprio-=sys->total;
				if (p->kprio>=sys->total) p->kprio=0;
				nq=p->comptsp;
				if (present(nq)) nq=(sys->sid)[nq]->next;
					else nq=Nid;
				j=-1;
				do
				  {
				  g=j;
				  while(nq!=Nid) /* boucle sur les sous-process */
				  	{
				  	q=(sys->sid)[nq];
				  	  /* gestion de la minuterie */
					if ((q->flclock)&&(q->clockn-c<=0))
						{
						SendClock(c,nq);
						if (q->flclock>0)
						  q->clockn+=q->flclock;
						  else q->flclock=0;	
						}
		 			if (q->fls==1)
						{
						g+=2;
						p->calcs+=q->prs;
						q->kprios+=q->prs;
						if (q->kprios>=p->totals)
				/* sous-processus choisi proportionnellement*/
				/*  sa priorit */
						  {
						  q->kprios-=p->totals;
						  if (q->kprios>=p->totals)
							q->kprios=0;
						  process=np;
						  sprocess=p->comptsp=nq;
						  return q->spp;
						  }
						}
					nq=q->next;
					}
				  p->totals=p->calcs;
				  p->calcs=0;
				  nq=p->spro;
				  j=0;	
				  } while(g);
			/* plus de sous-processus actif -> mise en attente du processus*/
				p->fl=2;
				p->kprio=0;
				sys->calcu-=p->pr;
				f-=2;
				}
			}
		np=p->next;
		}
	  sys->total=sys->calcu;
	  sys->calcu=0;
	  np=sys->pro;
	  i=0;
	  } while(f);
	  		/* sortie du systme demande, ou aucun sous-processus actif */
	process=sys->psys;
	sprocess=sys->spsys;
	return (sys->sid)[sys->spsys]->spp;
	}

/* point d'entre du systme :
	installe tout
	lance le processus systme
	lance un processus utilisateur (name,pr)
	et un premier sous-processus (proce,prs,n,pnt)		*/
int desk(name,pr,proce,prs,n,pnt)
	char	*name;
	int	pr;
	void	(*proce)();
	int	prs;
	long	n;
	void	*pnt;
	{
		objet ob;
		struct SProcess SPsys;
	
	inigraflib();
	if (inisys()==NULL) return -1;

	process=sys->psys=CreateProcess("SYSTEME",256,sproc1sys,256,2048,NULL);
	sprocess=sys->spsys=NewID((void*)&SPsys);	/* sous-processus fantme */
	(sys->sid)[sys->spsys]->typ=-1;
	(sys->sid)[sys->spsys]->pere=sys->psys;
	(sys->sid)[sys->spsys]->maskcomm=0;
	ob=inicsrstand();
	empile(ob,0);
	sys->obmouse=sys->obml=ob;
	affscreen();
	
	CreateProcess(name,pr,proce,prs,n,pnt);
		
	asm
		{
		MOVE.L	A5,SAVEA5
		MOVE.L	0X64,ADINT
		MOVE.W	#-2,FLINT
		CLR.W	FLINTB
		MOVE.L	SP,SPMASTER
		SUB.L	#1024,SPMASTER	/* calcule le sp normal utilis
					pour contrer le 'stack sniffer' */
		LEA.L	@INTERRUPT,A0
		MOVE.L	A0,0X64	/* installe l'interruption */
		BRA	@FIN

	@INTERRUPT
		TST.W	FLINTB
		BNE	@ENDD	/* cas de l'interruption se produisant
				avant la fin du traitement de la prcdente */
		NOT.W	FLINTB

		TST.W	FLINT
		BPL	@END	/* pas de routine spciale  excuter */ 
		ADDQ.W	#1,FLINT	/* pendant cette interruption */
		BNE	@END

		MOVEM.L	D0-D7/A0-A6,-(SP)
		MOVE.L	SAVEA5,A5
		MOVE.L	SP,SPBUF
		MOVE.L	SPMASTER,SP
		MOVE.W	#0X64,-(SP)
		PEA	@INT2
		MOVE.W	#0X2000,-(SP)
		MOVE.L	ADINT,-(SP)
		RTS		/* appel de la routine standard du Mac */
		
	@INT2	JSR	TstEvent
		JSR	affn
		JSR	rnd
		OR.W	#0X100,SR
		MOVE.L	SPBUF,D0
		MOVE.L	D0,-(SP)
		JSR	scheduler
		MOVE.L	D0,SP
		MOVEM.L	(SP)+,D0-D7/A0-A6
		MOVE.W	#-2,FLINT
		CLR.W	FLINTB
		RTE		/* retour  la nouvelle tche */
		
	@END	MOVE.L	SP,SPBUF
		MOVE.L	SPMASTER,SP
		MOVE.W	#0X64,-(SP)
		PEA	@INT3
		MOVE.W	#0X2100,-(SP)
	@ENDD	MOVE.L	ADINT,-(SP)
		RTS
		
	@INT3	MOVE.L	SPBUF,SP
		CLR.W	FLINTB
		RTE
	@FIN
		}
				/* routine du sous-processus fantme */
	while(sys->state>=0);
	asm
		{		/* restauration du vecteur d'interruption */
		MOVE.L	ADINT,0X64
		}
	endsys();
	endgraflib();
	}

