#include "desk.h"

/*	programme de gestion d'un PARKING
	nmaxcars voitures
	1 entre
	1 sortie	*/

#define nmaxcars 16
	
struct Park
	{
	objet	entree,sortie,cars;
	cas	endc;
	int	main;
	int	gardentree;
	int	gardsortie;
	int	Cars[nmaxcars];
	int	scan;
	};
typedef struct Park *park;

/* initialisation des fentres	*/
void iniparking(p)
	park	p;
	{
	SetMaskComm(CError);
	p->entree=newwind(216,300,0x8000,0,1,0,10);
	p->sortie=newwind(200,300,0x8000,0,1,0,10);
	p->cars=newwind(200,200,0x8000,0,1,2,10);
	if (GetError()) EndProcess();

	p->endc=setbarre(p->entree,"Entree",sprocess);
	setbarre(p->sortie,"Sortie",Nid);
	setbarre(p->cars,"Voitures",Nid);
	
	empile(p->sortie,1);
	empile(p->entree,1);
	empile(p->cars,1);
	affscreen();
	}

/* sous-processus grant la fentres des voitures	*/
void scan()
	{
		park	p=GetParam();
		Point	q;
		objet	ob=p->cars;
	
	locate(ob,0,0,0);
	println(ob,0,"Ext : a l'exterieur");
	println(ob,0,"Att : file d'attente");
	println(ob,0,"Int : a l'interieur");
	while(1)
		{
		WaitforComm(CMove);
		GetMove(&q);
		
		locate(ob,0,0,q.h+4);
		printhexint(ob,0,q.h);
		if (q.v==0) printchn(ob,0," Ext        ");
		if (q.v==1) printchn(ob,0,"     Att    ");
		if (q.v==2) printchn(ob,0,"         Int");
		afworkmodif(ob);
		}
	}

/* sous-processus gardien d'entre
	(comptable du nombre de voitures dans le parking)	*/
void gardentree()
	{
		park	p=GetParam();
		int	nblibre=5;
		Point	q;
		objet	ob=p->entree;
		int	queue[nmaxcars];
		int	pe=0, pl=0;
		int	k;

	while(1)	{
		k=WaitforComm(CMove+CInt);
		if (k==CMove)	/* une voiture veut entrer	*/
			{
			GetMove(&q);
			printchn(ob,0,"] Demande d'acces : ");
			printhexint(ob,0,q.h);
			println(ob,0," ");
			println(ob,0," ");
			afworkmodif(ob);
			queue[pe++]=q.h;
			if (pe==nmaxcars) pe=0;
			}
		if (k==CInt)
			{	/* une place a t libre	*/
			GetInt();
			println(ob,0,"> une place liberee");
			println(ob,0," ");
			afworkmodif(ob);
			nblibre++;
			}
		while((pe!=pl)&&(nblibre))
			{	/* autorise une voiture  entrer
				s'il reste des places	*/
			k=queue[pl++];
			if (pl==nmaxcars) pl=0;
			printchn(ob,0,"] Acces autorise : ");
			printhexint(ob,0,k);
			println(ob,0,"");
			println(ob,0," ");
			afworkmodif(ob);
			SendInt(0,p->Cars[k]);
			nblibre--;
			}
		}	
	}
	
/* sous-processus gardien de la sortie	*/
void gardsortie()
	{
		park	p=GetParam();
		objet	ob=p->sortie;
		Point	q;
	
	while(1)	{
		WaitforComm(CMove);	/* attend la sortie d'une voiture	*/
		GetMove(&q);
		printchn(ob,0,"] Sortie de : ");
		printhexint(ob,0,q.h);
		println(ob,0,"");
		afworkmodif(ob);
		SendInt(0,p->gardentree); /* prvient le garde d'entre	*/
		}
	}

/* sous-processus d'une voiture	*/
void car()
	{
		park	p=GetParam();
		int	n,state=0;
		int	c,w,i;
	
	SetMaskComm(CInt);
	SendInt(0,p->main);	
	WaitforComm(CInt);	/* identification de la voiture :
			le sous-processus principal lui envoye son numro	*/
	n=GetInt();
	
	while(1)	{
		SendMove(n,0,p->scan);	/* la voiture est  l'extrieur	*/
		w=(rnd()&255)*5+200;
		OnceRing(w);
		WaitforComm(CClock);	/* attend un certain temps  l'extrieur	*/
		GetClock();

		SendMove(n,1,p->scan);
		SendMove(n,0,p->gardentree);	/* demande  entrer dans le parking	*/
		WaitforComm(CInt);	/* attend l'autorisation	*/
		i=GetInt();
		
		SendMove(n,2,p->scan);	/* la voiture est  l'intrieur	*/
		w=(rnd()&255)*5+200;
		OnceRing(w);
		WaitforComm(CClock);	/* attend un certain temps  l'intrieur	*/
		GetClock();

		SendMove(n,0,p->scan);
		SendMove(n,0,p->gardsortie); /* la voiture sort du parking	*/
		}
	}

/* point d'entre du programme : sous-processus principal	*/
void parking()
	{
		struct Park	P;
		Mouse	m;
		int	i;

	iniparking(&P);
	P.main=sprocess;		/* cration des sous-processus	*/
	P.scan=CreateSProcess(scan,90,2048,&P);
	P.gardentree=CreateSProcess(gardentree,30,2048,&P);
	P.gardsortie=CreateSProcess(gardsortie,30,2048,&P);
	SetMaskComm(CInt);
	for(i=0;i<nmaxcars;i++)
		{
		P.Cars[i]=CreateSProcess(car,30,2048,&P);
		WaitforComm(CInt); GetInt();
		SendInt(i,P.Cars[i]);	/* identification des voitures	*/
		}	
	
	do	{
		WaitforComm(CClickE);
		GetClickE(&m);	/* attend un click sur la case de destruction	*/
		}
	while(m.ca!=P.endc);
	EndProcess();	/* fin de l'application	*/
	}