#include "desk.h"
/* programme d'observation du systme :
	- observation des processus
	- observation des sous-processus d'un processus
	- observation de la gestion de la mmoire	*/
struct Scan
	{
	objet obp,obsp,obmem,menu;
	int ps;
	int nmem,np,nsp;
	int spro,sspro,smem;
	};
typedef struct Scan *scan;

/* interprtation de l'tat d'un processus ou d'un sous-processus	*/
char *type(k)
	int	k;
	{
	if (k==-1) return "SUSPENDU";
	if (k==2) return "ATTENTE ";
	if (k==1) return "NORMAL  ";
	return "   --   ";
	}

/* quelques routines pour la saisie du niveau de priorit	*/
int valc(c)
	char c;
	{
	if ((c-=48)<0) return -1;
	if (c<10) return c;
	if ((c-=7)<10) return -1;
	if (c<16) return c;
	if ((c-=32)<10) return -1;
	if (c<16) return c;
	return -1;
	}

long val(ch)
	char *ch;
	{
		int	i=0,f=1;
		long	v=0;
		char	c;

	while((c=ch[i])&&(f))
		{
		if ((c=valc(c))!=-1) v=v*16+c ;
			else
			{
			f=0;
			v=0;
			}
		i++;
		}
	return v;
	} 

int asklevel(n)
	int	n;
	{
	objet	ob;
	cas	c;
	char	ch[5];
	int	k=n;
	
	ob=newwind(250,80,0x8000,0,1,0,5);
	if (ob)	{
		empile(ob,1);
		setbarre(ob,"Priorite",Nid);
		c=DefCasInput(ob,0,2,10,248,78,0);
		locate(ob,0,1,2);
		printchn(ob,0,"Priorite actuelle : ");
		printhexint(ob,0,n);
		locate(ob,0,1,4);
		printchn(ob,0,"Nouvelle priorite : ");
		affobjet(ob);
		inputchn(ob,0,c,ch,0,4);
		k=val(ch);
		if (k==0) k=n;
		killob(ob);
		}
	return k;
	}

/* retourne le nombre de bloc mmoire allous	*/
int nbmem()
	{
		mem	p=sys->first;
		int	i=1;
	
	while(p=p->next) i++;
	return i;
	}

/* retourne le nombre de processus	*/
int nbpro()
	{
		int	p=sys->pro;
		int	i=0;
	
	Bloque;
	while(present(p))
		{
		p=(sys->pid)[p]->next;
		i++;
		}
	Debloque;
	return i;
	}

/* retourne le nombre de sous-processus	*/
int nbspro(p)
	int p;
	{
		int	q;
		int	i=0;
	
	Bloque;
	if(!present(p))
		{
		Debloque;
		return 0;
		}
	q=(sys->pid)[p]->spro;
	while(present(q))
		{
		q=(sys->sid)[q]->next;
		i++;
		}
	Debloque;
	return i;
	}

/* sous-processus d'observation des processus	*/
void scannpro()
{
	scan	s=(scan)GetParam();
	int	i,k;
	int	p,ps;
	proc	pp;
	objet	ob=s->obp;
	cas	endp,choice,nivp;
	long	t;
	Mouse	m;
	int	nmax;
	
standard(ob,"Process",&endp,&s->np,&nmax,NULL,NULL,-1,NULL,NULL);
choice=newcvide(ob,0,2,26,297,25+8*16,0,0,0,sprocess,Nid);
nivp=newcvide(ob,0,256,26,297,25+8*26,0,0,0,sprocess,Nid);
locate(ob,0,0,0);
printchn(ob,0," ID     NOM            ETAT     PRIO");
locate(ob,0,0,19);
printchn(ob,0,"Clicker pour changer de processus");
empile(ob,1);
affobjet(ob);

AlwaysRing(60);
SendClock(0,sprocess);
while(1)	{
	t=WaitforComm(CClock+CClickE+CClick+CPoint);
	if(t==CClock) while(GetClock()!=0x8000);
	if (t==CClickE)
		{
		GetClickE(&m);
		if (m.ca==endp)
			{
			depile(ob);
			affobjet(ob);
			s->spro=Nid;
			EndSProcess();
			}
		}
	if (t==CClick)
		{
		GetClick(&m);
		if (m.ca==choice)
			{
			s->ps=procn(s->np+m.dy/8);
			s->nsp=0;
			}
		if (m.ca==nivp)
			{
			p=procn(s->np+m.dy/8);
			if (present(p)) LevelProcess(p,asklevel((sys->pid)[p]->pr));
			}
		}
	if (t==CPoint) while(GetPoint());

	ps=s->ps;
	k=s->np*nbpro()/nmax;
	for (i=0;i<16;i++)
		{
		p=procn(k+i);
		if((p==ps)&&(p!=Nid)) print(ob,0,14);
		locate(ob,0,0,i+2);
		if (p==Nid) printchn(ob,0,
			" --                                 ");
			else 
			{
			pp=(sys->pid)[p];
			printhexint(ob,0,p);
			printchn(ob,0,"  ");
			printchn(ob,0,pp->name);
			printchn(ob,0," ");
			printchn(ob,0,type(pp->fl));
			printchn(ob,0,"  ");
			printhexint(ob,0,pp->pr);
			}
		if(p==ps) print(ob,0,15);
		}
	afworkmodif(ob);
	
	}
}

/* sous-processus d'observation des sous-processus	*/
void scannspro()
{
	scan	s=(scan)GetParam();
	int	i,k;
	int	ps;
	int	q;
	sproc	qq;
	objet	ob=s->obsp;
	cas	endsp,nivsp;
	long	t;
	Mouse	m;
	int	nmax;

standard(ob,"Sous-Process",&endsp,&s->nsp,&nmax,NULL,NULL,-1,NULL,NULL);
nivsp=newcvide(ob,0,128,26,168,25+8*16,0,0,0,sprocess,Nid);
empile(ob,1);
affobjet(ob);

AlwaysRing(60);
SendClock(0,sprocess);

while(1)
	{
	t=WaitforComm(CClock+CClickE+CClick+CPoint);
	if(t==CClock) while(GetClock()!=0x8000);
	if (t==CClickE)
		{
		GetClickE(&m);
		if (m.ca==endsp)
			{
			depile(ob);
			affobjet(ob);
			s->sspro=Nid;
			EndSProcess();
			}
		}
	if (t==CClick)
		{
		GetClick(&m);
		if (m.ca==nivsp)
			{
			q=sprocn(s->nsp+m.dy/8 , s->ps);
			if (present(q)) LevelSProcess(q,asklevel((sys->sid)[q]->prs));
			}
		}
	if (t==CPoint) while(GetPoint());

	if (!present(s->ps)) s->ps=Nid;
	ps=s->ps;
	if (ps==Nid)
	  cls(ob,0);
	  else
	  {
	  locate(ob,0,0,0);
	  printchn(ob,0," ID    ETAT     PRIO  MASKCOMM");
	  k=s->nsp*nbspro(ps)/nmax;
	  for (i=0;i<16;i++)
		{
		q=sprocn(k+i,ps);
		locate(ob,0,0,i+2);
		if (q==Nid) printchn(ob,0,
			" --                                 ");
			else
			{
			qq=(sys->sid)[q];
			printhexint(ob,0,q);
			printchn(ob,0,"  ");
			printchn(ob,0,type(qq->fls));
			printchn(ob,0,"  ");
			printhexint(ob,0,qq->prs);
			printchn(ob,0,"  ");
			printhexlong(ob,0,qq->maskcomm);
			}
		}
	  }
	afworkmodif(ob);
	}
}

/* sous-processus d'observation de la gestion mmoire	*/
void scannmem()
{
	scan	s=(scan)GetParam();
	int	i,k;
	objet	ob=s->obmem;
	cas	endmem;
	long	t;
	Mouse	mm;
	mem	l,m;
	int	nmax;

standard(ob,"Memory",&endmem,&s->nmem,&nmax,NULL,NULL,-1,NULL,NULL);
empile(ob,1);
affobjet(ob);

AlwaysRing(60);
SendClock(0,sprocess);

while(1)
	{
	t=WaitforComm(CClock+CClickE+CPoint);
	if(t==CClock) while(GetClock()!=0x8000);
	if (t==CClickE)
		{
		GetClickE(&mm);
		if (mm.ca==endmem)
			{
			depile(ob);
			affobjet(ob);
			s->smem=Nid;
			EndSProcess();
			}
		}
	if (t==CPoint) while(GetPoint());

	k=s->nmem*nbmem()/nmax;
	m=memn(k);
	for(i=0;i<32;i++)
		{
		locate(ob,0,0,i);
		if (m)	{
			if (m->deb==NULL)
				{
				printchn(ob,0,"> BASE  : ");
				printhexlong(ob,0,(long)m->end);
				printchn(ob,0,"                  ");
				}
			if (m->end==NULL)
				{
				printchn(ob,0,"> FIN   : ");
				printhexlong(ob,0,(long)m->deb);
				printchn(ob,0,"                  ");
				}
			if ((m->deb)&&(m->end))
				{
				if((m->np!=l->np)||(m->np!=m->next->np))
					printchn(ob,0,(sys->pid)[m->np]->name);
					else
					printchn(ob,0,"   --      --  ");
				printchn(ob,0,"  ");
				printhexlong(ob,0,(long)m->deb);
				printchn(ob,0,"  ");
				if((void*)m->next!=m->end)
					printhexlong(ob,0,(long)m->end);
					else
					printchn(ob,0,".../... ");
				}
			l=m;
			m=m->next;
			}
			else
			printchn(ob,0,"                                   ");
		}
	afworkmodif(ob);
	}
}

/* point d'entre du programme : sous-processus principal	*/
void scanning()
{
	cas	endc;
	cas	chp,chsp,chmem;
	Mouse	m;
	struct Scan	s;
	int	k;

SetMaskComm(CError);
s.menu=newwind(146,68,0x8000,0,1,0,10);
s.obsp=newwind(300,172,0x8000,0,1,2,10);
s.obp=newwind(308,172,0x8000,0,1,2,10);
s.obmem=newwind(316,280,0x8000,0,1,2,10);
if (GetError()) EndProcess();

endc=setbarre(s.menu,"Scanning",sprocess);
chp=newc(s.menu,0,"   process   ",20,20,2,0,1,sprocess,Nid);
chsp=newc(s.menu,0,"  ss-process ",20,36,2,0,1,sprocess,Nid);
chmem=newc(s.menu,0,"   memory    ",20,52,2,0,1,sprocess,Nid);

s.ps=Nid;
s.smem=s.spro=s.sspro=Nid;

empile(s.menu,1);
affobjet(s.menu);

do	{
	WaitforComm(CClickE);
	GetClickE(&m);
	if (m.ca==endc) k=-1;
	if ((m.ca==chp)&&(s.spro==Nid))
		s.spro=CreateSProcess(scannpro,30,2048,&s);
	if ((m.ca==chsp)&&(s.sspro==Nid))
		s.sspro=CreateSProcess(scannspro,30,2048,&s);
	if ((m.ca==chmem)&&(s.smem==Nid))
		s.smem=CreateSProcess(scannmem,30,2048,&s);
	}
while(k!=-1);
EndProcess();
}
